open Datatypes

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

type 'm coq_Monad = { ret : (__ -> __ -> 'm);
                      bind : (__ -> __ -> 'm -> (__ -> 'm) -> 'm) }

(** val ret : 'a1 coq_Monad -> 'a2 -> 'a1 **)

let ret monad x =
  let { ret = ret0; bind = _ } = monad in Obj.magic ret0 __ x

(** val bind : 'a1 coq_Monad -> 'a1 -> ('a2 -> 'a1) -> 'a1 **)

let bind monad x x0 =
  let { ret = _; bind = bind0 } = monad in Obj.magic bind0 __ __ x x0

type ('e, 'm) coq_MonadExc = { raise : (__ -> 'e -> 'm);
                               catch : (__ -> 'm -> ('e -> 'm) -> 'm) }

(** val raise : ('a1, 'a2) coq_MonadExc -> 'a1 -> 'a2 **)

let raise monadExc x =
  monadExc.raise __ x

(** val catch : ('a1, 'a2) coq_MonadExc -> 'a2 -> ('a1 -> 'a2) -> 'a2 **)

let catch monadExc x x0 =
  monadExc.catch __ x x0

module MonadNotation =
 struct
 end

(** val option_monad : __ option coq_Monad **)

let option_monad =
  { ret = (fun _ a -> Some a); bind = (fun _ _ m f ->
    match m with
    | Some a -> f a
    | None -> None) }

(** val mapopt : ('a1 -> 'a1 option) -> 'a1 list -> 'a1 list option **)

let rec mapopt f = function
| [] -> ret (Obj.magic option_monad) []
| x :: xs ->
  bind (Obj.magic option_monad) (Obj.magic f x) (fun x' ->
    bind (Obj.magic option_monad) (mapopt f xs) (fun xs' ->
      ret (Obj.magic option_monad) (x' :: xs')))

(** val monad_map : 'a1 coq_Monad -> ('a2 -> 'a1) -> 'a2 list -> 'a1 **)

let rec monad_map m f = function
| [] -> ret m []
| x :: l0 ->
  bind m (f x) (fun x' ->
    bind m (monad_map m f l0) (fun l' -> ret m (x' :: l')))

(** val monad_fold_left :
    'a1 coq_Monad -> ('a2 -> 'a3 -> 'a1) -> 'a3 list -> 'a2 -> 'a1 **)

let rec monad_fold_left m g l x =
  match l with
  | [] -> ret m x
  | y :: l0 -> bind m (g x y) (fun x' -> monad_fold_left m g l0 x')

(** val monad_map_i_aux :
    'a1 coq_Monad -> (nat -> 'a2 -> 'a1) -> nat -> 'a2 list -> 'a1 **)

let rec monad_map_i_aux m h n0 = function
| [] -> ret m []
| x :: l0 ->
  bind m (h n0 x) (fun x' ->
    bind m (monad_map_i_aux m h (S n0) l0) (fun l' -> ret m (x' :: l')))

(** val monad_map_i :
    'a1 coq_Monad -> (nat -> 'a2 -> 'a1) -> 'a2 list -> 'a1 **)

let monad_map_i m h =
  monad_map_i_aux m h O

(** val monad_iter : 'a1 coq_Monad -> ('a2 -> 'a1) -> 'a2 list -> 'a1 **)

let monad_iter m f l =
  monad_fold_left m (fun _ -> f) l ()
