open Ast0
open BasicAst
open Checker0
open Datatypes
open LiftSubst
open List0
open Universes0
open Monad_utils
open Utils

(** val infer_spine :
    coq_Fuel -> global_env -> context -> term -> term list -> term
    typing_result **)

let rec infer_spine f _UU03a3_ _UU0393_ ty = function
| [] -> ret (Obj.magic typing_monad) ty
| x :: xs ->
  bind (Obj.magic typing_monad)
    (Obj.magic reduce_to_prod f _UU03a3_ _UU0393_ ty) (fun pi ->
    let (_, b1) = pi in infer_spine f _UU03a3_ _UU0393_ (subst1 x O b1) xs)

(** val type_of_as_sort :
    coq_Fuel -> global_env -> (context -> term -> term typing_result) ->
    context -> term -> universe typing_result **)

let type_of_as_sort f _UU03a3_ type_of0 _UU0393_ t =
  bind (Obj.magic typing_monad) (Obj.magic type_of0 _UU0393_ t) (fun tx ->
    reduce_to_sort f _UU03a3_ _UU0393_ tx)

(** val type_of :
    coq_Fuel -> global_env -> context -> term -> term typing_result **)

let rec type_of f _UU03a3_ _UU0393_ = function
| Coq_tRel n ->
  (match nth_error _UU0393_ n with
   | Some d -> ret (Obj.magic typing_monad) (lift (S n) O d.decl_type)
   | None -> raise (Obj.magic monad_exc) (UnboundRel n))
| Coq_tVar n -> raise (Obj.magic monad_exc) (UnboundVar n)
| Coq_tEvar (ev, _) -> raise (Obj.magic monad_exc) (UnboundEvar ev)
| Coq_tSort s -> ret (Obj.magic typing_monad) (Coq_tSort (Universe.try_suc s))
| Coq_tCast (_, _, t0) -> ret (Obj.magic typing_monad) t0
| Coq_tProd (n, t0, b) ->
  bind (Obj.magic typing_monad)
    (Obj.magic type_of_as_sort f _UU03a3_ (type_of f _UU03a3_) _UU0393_ t0)
    (fun s1 ->
    bind (Obj.magic typing_monad)
      (Obj.magic type_of_as_sort f _UU03a3_ (type_of f _UU03a3_)
        (snoc _UU0393_ (vass n t0)) b) (fun s2 ->
      ret (Obj.magic typing_monad) (Coq_tSort
        (Universe.sort_of_product s1 s2))))
| Coq_tLambda (n, t0, b) ->
  bind (Obj.magic typing_monad)
    (type_of f _UU03a3_ (snoc _UU0393_ (vass n t0)) b) (fun t2 ->
    ret (Obj.magic typing_monad) (Coq_tProd (n, t0, t2)))
| Coq_tLetIn (n, b, b_ty, b') ->
  bind (Obj.magic typing_monad)
    (type_of f _UU03a3_ (snoc _UU0393_ (vdef n b b_ty)) b') (fun b'_ty ->
    ret (Obj.magic typing_monad) (Coq_tLetIn (n, b, b_ty, b'_ty)))
| Coq_tApp (t0, l) ->
  bind (Obj.magic typing_monad) (type_of f _UU03a3_ _UU0393_ t0) (fun t_ty ->
    infer_spine f _UU03a3_ _UU0393_ t_ty l)
| Coq_tConst (cst, u) -> lookup_constant_type _UU03a3_ cst u
| Coq_tInd (ind0, u) ->
  let { inductive_mind = ind; inductive_ind = i } = ind0 in
  lookup_ind_type _UU03a3_ ind i u
| Coq_tConstruct (ind0, k, u) ->
  let { inductive_mind = ind; inductive_ind = i } = ind0 in
  lookup_constructor_type _UU03a3_ ind i k u
| Coq_tCase (ind_and_nbparams, p, c, _) ->
  let (_, par) = ind_and_nbparams in
  bind (Obj.magic typing_monad) (type_of f _UU03a3_ _UU0393_ c) (fun ty ->
    bind (Obj.magic typing_monad)
      (Obj.magic reduce_to_ind f _UU03a3_ _UU0393_ ty) (fun indargs ->
      let (_, args) = indargs in
      ret (Obj.magic typing_monad) (Coq_tApp (p,
        (app (skipn par args) (c :: []))))))
| Coq_tProj (_, c) ->
  bind (Obj.magic typing_monad) (type_of f _UU03a3_ _UU0393_ c) (fun ty ->
    bind (Obj.magic typing_monad)
      (Obj.magic reduce_to_ind f _UU03a3_ _UU0393_ ty) (fun _ ->
      ret (Obj.magic typing_monad) ty))
| Coq_tFix (mfix, n) ->
  (match nth_error mfix n with
   | Some f0 -> ret (Obj.magic typing_monad) f0.dtype
   | None -> raise (Obj.magic monad_exc) (IllFormedFix (mfix, n)))
| Coq_tCoFix (mfix, n) ->
  (match nth_error mfix n with
   | Some f0 -> ret (Obj.magic typing_monad) f0.dtype
   | None -> raise (Obj.magic monad_exc) (IllFormedFix (mfix, n)))

(** val sort_of :
    coq_Fuel -> global_env -> context -> term -> universe typing_result **)

let sort_of f _UU03a3_ _UU0393_ t =
  bind (Obj.magic typing_monad) (Obj.magic type_of f _UU03a3_ _UU0393_ t)
    (fun ty -> type_of_as_sort f _UU03a3_ (type_of f _UU03a3_) _UU0393_ ty)
