open Ast0
open Datatypes
open Specif
open Typing0
open Config0
open Utils

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

type wf_decl_pred = __

(** val coq_All_local_env_wf_decl :
    context -> wf_decl_pred coq_All_local_env **)

let rec coq_All_local_env_wf_decl = function
| [] -> Coq_localenv_nil
| y :: l0 ->
  let { decl_name = na; decl_body = decl_body0; decl_type = x } = y in
  (match decl_body0 with
   | Some body ->
     Coq_localenv_cons_def (l0, na, body, x, (coq_All_local_env_wf_decl l0),
       __, __)
   | None ->
     Coq_localenv_cons_abs (l0, na, x, (coq_All_local_env_wf_decl l0), __))

(** val coq_All_local_env_wf_decl_inv :
    context_decl -> context_decl list -> wf_decl_pred coq_All_local_env ->
    wf_decl_pred on_local_decl * wf_decl_pred coq_All_local_env **)

let coq_All_local_env_wf_decl_inv _ _ x =
  let x0 = fun _ ->
    match x with
    | Coq_localenv_nil -> assert false (* absurd case *)
    | Coq_localenv_cons_abs (_, _, _, x0, _) -> (__, x0)
    | Coq_localenv_cons_def (_, _, _, _, x0, _, _) -> (__, x0)
  in
  Obj.magic x0 __

(** val coq_OnOne2_All_All :
    'a1 list -> 'a1 list -> ('a1, 'a2) coq_OnOne2 -> ('a1 -> 'a1 -> 'a2 ->
    'a3 -> 'a3) -> ('a1, 'a3) coq_All -> ('a1, 'a3) coq_All **)

let rec coq_OnOne2_All_All _ _ hl h h' =
  match hl with
  | OnOne2_hd (hd, hd', tl, y) ->
    (match h' with
     | All_nil -> assert false (* absurd case *)
     | All_cons (_, _, x, x0) -> All_cons (hd', tl, (h hd hd' y x), x0))
  | OnOne2_tl (hd, tl, tl', o) ->
    (match h' with
     | All_nil -> assert false (* absurd case *)
     | All_cons (_, _, x, x0) ->
       All_cons (hd, tl', x, (coq_OnOne2_All_All tl tl' o h x0)))

(** val coq_All_mapi :
    'a1 list -> (nat -> 'a1 -> 'a2) -> ('a1, 'a3) coq_Alli -> ('a2, 'a3)
    coq_All **)

let coq_All_mapi l f =
  let n = O in
  (fun x ->
  let rec f0 n0 _ = function
  | Alli_nil -> All_nil
  | Alli_cons (hd, tl, y, a0) ->
    All_cons ((f n0 hd),
      (let rec mapi_rec f1 l0 n1 =
         match l0 with
         | [] -> []
         | hd0 :: tl0 -> (f1 n1 hd0) :: (mapi_rec f1 tl0 (S n1))
       in mapi_rec f tl (S n0)), y, (f0 (S n0) tl a0))
  in f0 n l x)

(** val coq_Alli_id :
    nat -> 'a1 list -> (nat -> 'a1 -> 'a2) -> ('a1, 'a2) coq_Alli **)

let rec coq_Alli_id n l h =
  match l with
  | [] -> Alli_nil
  | y :: l0 -> Alli_cons (y, l0, (h n y), (coq_Alli_id (S n) l0 h))

(** val coq_All_Alli :
    'a1 list -> nat -> ('a1, 'a2) coq_All -> (nat -> 'a1 -> 'a2 -> 'a3) ->
    ('a1, 'a3) coq_Alli **)

let rec coq_All_Alli _ n h x =
  match h with
  | All_nil -> Alli_nil
  | All_cons (x0, l, y, a) ->
    Alli_cons (x0, l, (x n x0 y), (coq_All_Alli l (S n) a x))

(** val typing_wf_gen : checker_flags -> __ env_prop **)

let typing_wf_gen cf =
  typing_ind_env cf (Obj.magic __) (Obj.magic __) (Obj.magic __)
    (Obj.magic __) (Obj.magic __) (Obj.magic __) (Obj.magic __)
    (Obj.magic __) (Obj.magic __) (Obj.magic __) (Obj.magic __)
    (Obj.magic __) (Obj.magic __) (Obj.magic __) (Obj.magic __)

(** val typing_wf_sigma :
    checker_flags -> global_env -> wf -> wf_decl_pred on_global_env **)

let typing_wf_sigma cf _UU03a3_ wf_UU03a3_ =
  let x = env_prop_sigma cf (typing_wf_gen cf) _UU03a3_ wf_UU03a3_ in
  let x0 =
    on_global_env_mix cf _UU03a3_ (fun _ _ b _ _ x0 ->
      match b with
      | Some x1 -> Obj.magic __ x1 x0
      | None ->
        let Coq_existT (u, _) = Obj.magic x0 in Obj.magic (Coq_existT (u, __)))
      wf_UU03a3_ x
  in
  on_global_env_impl cf _UU03a3_ (Obj.magic __) x0
