open Ast0
open BasicAst
open Bool
open Datatypes
open List0
open Nat0
open PeanoNat
open String0
open Universes0
open Utils

val string_of_list_aux :
  ('a1 -> char list) -> char list -> 'a1 list -> char list

val string_of_list : ('a1 -> char list) -> 'a1 list -> char list

val string_of_level : Level.t -> char list

val string_of_level_expr : (Level.t * bool) -> char list

val string_of_sort : universe -> char list

val string_of_name : name -> char list

val string_of_universe_instance : Level.t list -> char list

val string_of_def : ('a1 -> char list) -> 'a1 def -> char list

val string_of_inductive : inductive -> char list

val string_of_term : term -> char list

val mkLambda_or_LetIn : context_decl -> term -> term

val it_mkLambda_or_LetIn : context -> term -> term

val mkProd_or_LetIn : context_decl -> term -> term

val it_mkProd_or_LetIn : context -> term -> term

val map_decl : (term -> term) -> context_decl -> context_decl

val map_context : (term -> term) -> context_decl list -> context_decl list

val map_constant_body : (term -> term) -> constant_body -> constant_body

val map_def : ('a1 -> 'a2) -> ('a1 -> 'a2) -> 'a1 def -> 'a2 def

val app_context : context -> context -> context

val string_of_gref : global_reference -> char list

val gref_eq_dec : global_reference -> global_reference -> bool

val ident_eq : ident -> ident -> bool

val ident_eq_spec : ident -> ident -> reflect

val eq_string : char list -> char list -> bool

val eq_ind : inductive -> inductive -> bool

val eq_constant : char list -> char list -> bool

val eq_nat : nat -> nat -> bool

val eq_evar : nat -> nat -> bool

val eq_projection :
  ((inductive * nat) * nat) -> ((inductive * nat) * nat) -> bool

val decompose_app : term -> term * term list

val decompose_prod : term -> (name list * term list) * term

val get_ident : name -> char list

val remove_arity : nat -> term -> term

val lookup_mind_decl : ident -> global_env -> mutual_inductive_body option

val mind_body_to_entry : mutual_inductive_body -> mutual_inductive_entry

val arities_context : one_inductive_body list -> context_decl list

val decompose_prod_assum : context -> term -> context * term

val strip_outer_cast : term -> term

val decompose_prod_n_assum : context -> nat -> term -> (context * term) option

val is_ind_app_head : term -> bool

val reln : term list -> nat -> context_decl list -> term list

val to_extended_list_k : context_decl list -> nat -> term list

val to_extended_list : context_decl list -> term list

val reln_alt : nat -> context_decl list -> term list

val polymorphic_instance : universes_decl -> Instance.t

val context_assumptions : context -> nat

val map_one_inductive_body :
  nat -> nat -> (nat -> term -> term) -> nat -> one_inductive_body ->
  one_inductive_body

val fold_context : (nat -> term -> term) -> context -> context

val map_mutual_inductive_body :
  (nat -> term -> term) -> mutual_inductive_body -> mutual_inductive_body

val test_def : ('a1 -> bool) -> ('a1 -> bool) -> 'a1 def -> bool

val fst_ctx : global_env_ext -> global_env

val empty_ext : global_env -> global_env_ext
