open Datatypes

type ident = char list

type qualid = char list

type kername = char list

type name =
| Coq_nAnon
| Coq_nNamed of ident

val name_rect : 'a1 -> (ident -> 'a1) -> name -> 'a1

val name_rec : 'a1 -> (ident -> 'a1) -> name -> 'a1

type inductive = { inductive_mind : kername; inductive_ind : nat }

val inductive_mind : inductive -> kername

val inductive_ind : inductive -> nat

type projection = (inductive * nat) * nat

type 'term def = { dname : name; dtype : 'term; dbody : 'term; rarg : nat }

val dname : 'a1 def -> name

val dtype : 'a1 def -> 'a1

val dbody : 'a1 def -> 'a1

val rarg : 'a1 def -> nat

type 'term mfixpoint = 'term def list

type cast_kind =
| VmCast
| NativeCast
| Cast
| RevertCast

val cast_kind_rect : 'a1 -> 'a1 -> 'a1 -> 'a1 -> cast_kind -> 'a1

val cast_kind_rec : 'a1 -> 'a1 -> 'a1 -> 'a1 -> cast_kind -> 'a1

type recursivity_kind =
| Finite
| CoFinite
| BiFinite

val recursivity_kind_rect : 'a1 -> 'a1 -> 'a1 -> recursivity_kind -> 'a1

val recursivity_kind_rec : 'a1 -> 'a1 -> 'a1 -> recursivity_kind -> 'a1

type global_reference =
| VarRef of ident
| ConstRef of kername
| IndRef of inductive
| ConstructRef of inductive * nat

val global_reference_rect :
  (ident -> 'a1) -> (kername -> 'a1) -> (inductive -> 'a1) -> (inductive ->
  nat -> 'a1) -> global_reference -> 'a1

val global_reference_rec :
  (ident -> 'a1) -> (kername -> 'a1) -> (inductive -> 'a1) -> (inductive ->
  nat -> 'a1) -> global_reference -> 'a1
