
type uint =
| Nil
| D0 of uint
| D1 of uint
| D2 of uint
| D3 of uint
| D4 of uint
| D5 of uint
| D6 of uint
| D7 of uint
| D8 of uint
| D9 of uint

(** val uint_rect :
    'a1 -> (uint -> 'a1 -> 'a1) -> (uint -> 'a1 -> 'a1) -> (uint -> 'a1 ->
    'a1) -> (uint -> 'a1 -> 'a1) -> (uint -> 'a1 -> 'a1) -> (uint -> 'a1 ->
    'a1) -> (uint -> 'a1 -> 'a1) -> (uint -> 'a1 -> 'a1) -> (uint -> 'a1 ->
    'a1) -> (uint -> 'a1 -> 'a1) -> uint -> 'a1 **)

let rec uint_rect f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 = function
| Nil -> f
| D0 u0 -> f0 u0 (uint_rect f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D1 u0 -> f1 u0 (uint_rect f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D2 u0 -> f2 u0 (uint_rect f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D3 u0 -> f3 u0 (uint_rect f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D4 u0 -> f4 u0 (uint_rect f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D5 u0 -> f5 u0 (uint_rect f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D6 u0 -> f6 u0 (uint_rect f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D7 u0 -> f7 u0 (uint_rect f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D8 u0 -> f8 u0 (uint_rect f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D9 u0 -> f9 u0 (uint_rect f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)

(** val uint_rec :
    'a1 -> (uint -> 'a1 -> 'a1) -> (uint -> 'a1 -> 'a1) -> (uint -> 'a1 ->
    'a1) -> (uint -> 'a1 -> 'a1) -> (uint -> 'a1 -> 'a1) -> (uint -> 'a1 ->
    'a1) -> (uint -> 'a1 -> 'a1) -> (uint -> 'a1 -> 'a1) -> (uint -> 'a1 ->
    'a1) -> (uint -> 'a1 -> 'a1) -> uint -> 'a1 **)

let rec uint_rec f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 = function
| Nil -> f
| D0 u0 -> f0 u0 (uint_rec f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D1 u0 -> f1 u0 (uint_rec f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D2 u0 -> f2 u0 (uint_rec f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D3 u0 -> f3 u0 (uint_rec f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D4 u0 -> f4 u0 (uint_rec f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D5 u0 -> f5 u0 (uint_rec f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D6 u0 -> f6 u0 (uint_rec f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D7 u0 -> f7 u0 (uint_rec f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D8 u0 -> f8 u0 (uint_rec f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)
| D9 u0 -> f9 u0 (uint_rec f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 u0)

(** val int_rect : (uint -> 'a1) -> (uint -> 'a1) -> unit -> 'a1 **)

let int_rect f f0 i =
  (fun _ _ _ -> assert false)
    (fun x -> f x)
    (fun x -> f0 x)
    i

(** val int_rec : (uint -> 'a1) -> (uint -> 'a1) -> unit -> 'a1 **)

let int_rec f f0 i =
  (fun _ _ _ -> assert false)
    (fun x -> f x)
    (fun x -> f0 x)
    i

(** val nzhead : uint -> uint **)

let rec nzhead d = match d with
| D0 d0 -> nzhead d0
| _ -> d

(** val unorm : uint -> uint **)

let unorm d =
  match nzhead d with
  | Nil -> D0 Nil
  | x -> x

(** val norm : unit -> unit **)

let norm d =
  (fun _ _ _ -> assert false)
    (fun d0 -> (fun _ -> ()) (unorm d0))
    (fun d0 ->
    match nzhead d0 with
    | Nil -> (fun _ -> ()) (D0 Nil)
    | x -> (fun _ -> ()) x)
    d

(** val opp : unit -> unit **)

let opp d =
  (fun _ _ _ -> assert false)
    (fun d0 -> (fun _ -> ()) d0)
    (fun d0 -> (fun _ -> ()) d0)
    d

(** val revapp : uint -> uint -> uint **)

let rec revapp d d' =
  match d with
  | Nil -> d'
  | D0 d0 -> revapp d0 (D0 d')
  | D1 d0 -> revapp d0 (D1 d')
  | D2 d0 -> revapp d0 (D2 d')
  | D3 d0 -> revapp d0 (D3 d')
  | D4 d0 -> revapp d0 (D4 d')
  | D5 d0 -> revapp d0 (D5 d')
  | D6 d0 -> revapp d0 (D6 d')
  | D7 d0 -> revapp d0 (D7 d')
  | D8 d0 -> revapp d0 (D8 d')
  | D9 d0 -> revapp d0 (D9 d')

(** val rev : uint -> uint **)

let rev d =
  revapp d Nil

module Little =
 struct
  (** val succ : uint -> uint **)

  let rec succ = function
  | Nil -> D1 Nil
  | D0 d0 -> D1 d0
  | D1 d0 -> D2 d0
  | D2 d0 -> D3 d0
  | D3 d0 -> D4 d0
  | D4 d0 -> D5 d0
  | D5 d0 -> D6 d0
  | D6 d0 -> D7 d0
  | D7 d0 -> D8 d0
  | D8 d0 -> D9 d0
  | D9 d0 -> D0 (succ d0)

  (** val double : uint -> uint **)

  let rec double = function
  | Nil -> Nil
  | D0 d0 -> D0 (double d0)
  | D1 d0 -> D2 (double d0)
  | D2 d0 -> D4 (double d0)
  | D3 d0 -> D6 (double d0)
  | D4 d0 -> D8 (double d0)
  | D5 d0 -> D0 (succ_double d0)
  | D6 d0 -> D2 (succ_double d0)
  | D7 d0 -> D4 (succ_double d0)
  | D8 d0 -> D6 (succ_double d0)
  | D9 d0 -> D8 (succ_double d0)

  (** val succ_double : uint -> uint **)

  and succ_double = function
  | Nil -> D1 Nil
  | D0 d0 -> D1 (double d0)
  | D1 d0 -> D3 (double d0)
  | D2 d0 -> D5 (double d0)
  | D3 d0 -> D7 (double d0)
  | D4 d0 -> D9 (double d0)
  | D5 d0 -> D1 (succ_double d0)
  | D6 d0 -> D3 (succ_double d0)
  | D7 d0 -> D5 (succ_double d0)
  | D8 d0 -> D7 (succ_double d0)
  | D9 d0 -> D9 (succ_double d0)
 end

(** val uint_of_uint : uint -> uint **)

let uint_of_uint i =
  i

(** val int_of_int : unit -> unit **)

let int_of_int i =
  i
