open Ast0
open AstUtils
open BasicAst
open Common0

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

type 'x coq_TM =
| Coq_tmReturn of 'x
| Coq_tmBind of __ coq_TM * (__ -> 'x coq_TM)
| Coq_tmPrint of term
| Coq_tmMsg of char list
| Coq_tmFail of char list
| Coq_tmEval of reductionStrategy * term
| Coq_tmDefinition_ of bool * ident * term option * term
| Coq_tmAxiom of ident * term
| Coq_tmLemma of ident * term
| Coq_tmFreshName of ident
| Coq_tmAbout of qualid
| Coq_tmCurrentModPath
| Coq_tmQuoteInductive of kername
| Coq_tmQuoteConstant of kername * bool
| Coq_tmQuoteUniverses
| Coq_tmInductive of mutual_inductive_entry
| Coq_tmExistingInstance of kername
| Coq_tmInferInstance of term

(** val coq_TM_rect :
    (__ -> __ -> 'a1) -> (__ -> __ -> __ coq_TM -> 'a1 -> (__ -> __ coq_TM)
    -> (__ -> 'a1) -> 'a1) -> (term -> 'a1) -> (char list -> 'a1) -> (__ ->
    char list -> 'a1) -> (reductionStrategy -> term -> 'a1) -> (bool -> ident
    -> term option -> term -> 'a1) -> (ident -> term -> 'a1) -> (ident ->
    term -> 'a1) -> (ident -> 'a1) -> (qualid -> 'a1) -> 'a1 -> (kername ->
    'a1) -> (kername -> bool -> 'a1) -> 'a1 -> (mutual_inductive_entry ->
    'a1) -> (kername -> 'a1) -> (term -> 'a1) -> 'a2 coq_TM -> 'a1 **)

let rec coq_TM_rect f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 f10 f11 f12 f13 f14 f15 f16 = function
| Coq_tmReturn a -> Obj.magic f __ a
| Coq_tmBind (t0, t1) ->
  Obj.magic f0 __ __ t0
    (Obj.magic coq_TM_rect f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 f10 f11 f12 f13
      f14 f15 f16 t0) t1 (fun a ->
    coq_TM_rect f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 f10 f11 f12 f13 f14 f15 f16
      (t1 a))
| Coq_tmPrint t0 -> f1 t0
| Coq_tmMsg s -> f2 s
| Coq_tmFail s -> f3 __ s
| Coq_tmEval (red, tm) -> f4 red tm
| Coq_tmDefinition_ (opaque, nm, type0, term0) -> f5 opaque nm type0 term0
| Coq_tmAxiom (nm, type0) -> f6 nm type0
| Coq_tmLemma (nm, type0) -> f7 nm type0
| Coq_tmFreshName i -> f8 i
| Coq_tmAbout q -> f9 q
| Coq_tmCurrentModPath -> f10
| Coq_tmQuoteInductive nm -> f11 nm
| Coq_tmQuoteConstant (nm, bypass_opacity) -> f12 nm bypass_opacity
| Coq_tmQuoteUniverses -> f13
| Coq_tmInductive m -> f14 m
| Coq_tmExistingInstance k -> f15 k
| Coq_tmInferInstance type0 -> f16 type0

(** val coq_TM_rec :
    (__ -> __ -> 'a1) -> (__ -> __ -> __ coq_TM -> 'a1 -> (__ -> __ coq_TM)
    -> (__ -> 'a1) -> 'a1) -> (term -> 'a1) -> (char list -> 'a1) -> (__ ->
    char list -> 'a1) -> (reductionStrategy -> term -> 'a1) -> (bool -> ident
    -> term option -> term -> 'a1) -> (ident -> term -> 'a1) -> (ident ->
    term -> 'a1) -> (ident -> 'a1) -> (qualid -> 'a1) -> 'a1 -> (kername ->
    'a1) -> (kername -> bool -> 'a1) -> 'a1 -> (mutual_inductive_entry ->
    'a1) -> (kername -> 'a1) -> (term -> 'a1) -> 'a2 coq_TM -> 'a1 **)

let rec coq_TM_rec f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 f10 f11 f12 f13 f14 f15 f16 = function
| Coq_tmReturn a -> Obj.magic f __ a
| Coq_tmBind (t0, t1) ->
  Obj.magic f0 __ __ t0
    (Obj.magic coq_TM_rec f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 f10 f11 f12 f13 f14
      f15 f16 t0) t1 (fun a ->
    coq_TM_rec f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 f10 f11 f12 f13 f14 f15 f16
      (t1 a))
| Coq_tmPrint t0 -> f1 t0
| Coq_tmMsg s -> f2 s
| Coq_tmFail s -> f3 __ s
| Coq_tmEval (red, tm) -> f4 red tm
| Coq_tmDefinition_ (opaque, nm, type0, term0) -> f5 opaque nm type0 term0
| Coq_tmAxiom (nm, type0) -> f6 nm type0
| Coq_tmLemma (nm, type0) -> f7 nm type0
| Coq_tmFreshName i -> f8 i
| Coq_tmAbout q -> f9 q
| Coq_tmCurrentModPath -> f10
| Coq_tmQuoteInductive nm -> f11 nm
| Coq_tmQuoteConstant (nm, bypass_opacity) -> f12 nm bypass_opacity
| Coq_tmQuoteUniverses -> f13
| Coq_tmInductive m -> f14 m
| Coq_tmExistingInstance k -> f15 k
| Coq_tmInferInstance type0 -> f16 type0

(** val coq_TypeInstance : coq_TMInstance **)

let coq_TypeInstance =
  { tmReturn = (Obj.magic (fun _ x -> Coq_tmReturn x)); tmBind =
    (Obj.magic (fun _ _ x x0 -> Coq_tmBind (x, x0))); tmFail =
    (Obj.magic (fun _ x -> Coq_tmFail x)); tmFreshName =
    (Obj.magic (fun x -> Coq_tmFreshName x)); tmAbout =
    (Obj.magic (fun x -> Coq_tmAbout x)); tmCurrentModPath = (fun _ ->
    Obj.magic Coq_tmCurrentModPath); tmQuoteInductive =
    (Obj.magic (fun x -> Coq_tmQuoteInductive x)); tmQuoteUniverses =
    (Obj.magic Coq_tmQuoteUniverses); tmQuoteConstant =
    (Obj.magic (fun x x0 -> Coq_tmQuoteConstant (x, x0))); tmMkInductive =
    (Obj.magic (fun x -> Coq_tmInductive x)); tmExistingInstance =
    (Obj.magic (fun x -> Coq_tmExistingInstance x)) }

(** val tmOpaqueDefinition :
    ident -> term option -> term -> kername coq_TM **)

let tmOpaqueDefinition nm type0 term0 =
  Coq_tmDefinition_ (true, nm, type0, term0)

(** val tmDefinition : ident -> term option -> term -> kername coq_TM **)

let tmDefinition nm type0 term0 =
  Coq_tmDefinition_ (false, nm, type0, term0)

(** val tmInductive' : mutual_inductive_body -> unit coq_TM **)

let tmInductive' mind =
  Coq_tmInductive (mind_body_to_entry mind)

(** val tmLemmaRed : ident -> reductionStrategy -> term -> kername coq_TM **)

let tmLemmaRed i rd ty =
  Coq_tmBind ((Coq_tmEval (rd, ty)), (fun ty0 -> Coq_tmLemma (i,
    (Obj.magic ty0))))

(** val tmAxiomRed : ident -> reductionStrategy -> term -> kername coq_TM **)

let tmAxiomRed i rd ty =
  Coq_tmBind ((Coq_tmEval (rd, ty)), (fun ty0 -> Coq_tmAxiom (i,
    (Obj.magic ty0))))

(** val tmDefinitionRed :
    bool -> ident -> reductionStrategy -> term option -> term -> kername
    coq_TM **)

let tmDefinitionRed opaque i rd ty body =
  match ty with
  | Some ty0 ->
    Coq_tmBind ((Coq_tmEval (rd, ty0)), (fun ty1 -> Coq_tmDefinition_
      (opaque, i, (Some (Obj.magic ty1)), body)))
  | None -> Coq_tmDefinition_ (opaque, i, None, body)

(** val tmInferInstanceRed :
    reductionStrategy -> term -> term option coq_TM **)

let tmInferInstanceRed rd type0 =
  Coq_tmBind ((Coq_tmEval (rd, type0)), (fun type1 -> Coq_tmInferInstance
    (Obj.magic type1)))
