open Ast0
open AstUtils
open BasicAst
open Common0

type __ = Obj.t

type 'x coq_TM =
| Coq_tmReturn of 'x
| Coq_tmBind of __ coq_TM * (__ -> 'x coq_TM)
| Coq_tmPrint of term
| Coq_tmMsg of char list
| Coq_tmFail of char list
| Coq_tmEval of reductionStrategy * term
| Coq_tmDefinition_ of bool * ident * term option * term
| Coq_tmAxiom of ident * term
| Coq_tmLemma of ident * term
| Coq_tmFreshName of ident
| Coq_tmAbout of qualid
| Coq_tmCurrentModPath
| Coq_tmQuoteInductive of kername
| Coq_tmQuoteConstant of kername * bool
| Coq_tmQuoteUniverses
| Coq_tmInductive of mutual_inductive_entry
| Coq_tmExistingInstance of kername
| Coq_tmInferInstance of term

val coq_TM_rect :
  (__ -> __ -> 'a1) -> (__ -> __ -> __ coq_TM -> 'a1 -> (__ -> __ coq_TM) ->
  (__ -> 'a1) -> 'a1) -> (term -> 'a1) -> (char list -> 'a1) -> (__ ->
  char list -> 'a1) -> (reductionStrategy -> term -> 'a1) -> (bool -> ident
  -> term option -> term -> 'a1) -> (ident -> term -> 'a1) -> (ident -> term
  -> 'a1) -> (ident -> 'a1) -> (qualid -> 'a1) -> 'a1 -> (kername -> 'a1) ->
  (kername -> bool -> 'a1) -> 'a1 -> (mutual_inductive_entry -> 'a1) ->
  (kername -> 'a1) -> (term -> 'a1) -> 'a2 coq_TM -> 'a1

val coq_TM_rec :
  (__ -> __ -> 'a1) -> (__ -> __ -> __ coq_TM -> 'a1 -> (__ -> __ coq_TM) ->
  (__ -> 'a1) -> 'a1) -> (term -> 'a1) -> (char list -> 'a1) -> (__ ->
  char list -> 'a1) -> (reductionStrategy -> term -> 'a1) -> (bool -> ident
  -> term option -> term -> 'a1) -> (ident -> term -> 'a1) -> (ident -> term
  -> 'a1) -> (ident -> 'a1) -> (qualid -> 'a1) -> 'a1 -> (kername -> 'a1) ->
  (kername -> bool -> 'a1) -> 'a1 -> (mutual_inductive_entry -> 'a1) ->
  (kername -> 'a1) -> (term -> 'a1) -> 'a2 coq_TM -> 'a1

val coq_TypeInstance : coq_TMInstance

val tmOpaqueDefinition : ident -> term option -> term -> kername coq_TM

val tmDefinition : ident -> term option -> term -> kername coq_TM

val tmInductive' : mutual_inductive_body -> unit coq_TM

val tmLemmaRed : ident -> reductionStrategy -> term -> kername coq_TM

val tmAxiomRed : ident -> reductionStrategy -> term -> kername coq_TM

val tmDefinitionRed :
  bool -> ident -> reductionStrategy -> term option -> term -> kername coq_TM

val tmInferInstanceRed : reductionStrategy -> term -> term option coq_TM
