open Ascii
open Ast0
open AstUtils
open BasicAst
open Datatypes
open LiftSubst
open List0
open Nat0
open String0
open Universes0
open Utils

val nl : char list

val print_list : ('a1 -> char list) -> char list -> 'a1 list -> char list

val parens : bool -> char list -> char list

val print_universe_instance : Level.t list -> char list

val print_lset : LevelSet.t -> char list

val print_constraint_type : ConstraintType.t -> char list

val print_constraint_set : ConstraintSet.t -> char list

val print_def :
  ('a1 -> char list) -> ('a1 -> char list) -> 'a1 def -> char list

val fix_context : term mfixpoint -> context

val print_defs :
  (context -> bool -> term -> char list) -> context -> term mfixpoint ->
  char list

val map2 : ('a1 -> 'a2 -> 'a3) -> 'a1 list -> 'a2 list -> 'a3 list

val decompose_lam : term -> nat -> (name list * term list) * term

val is_fresh : context -> ident -> bool

val global_decl_ident : global_decl -> kername

val lookup_env : global_env -> ident -> global_decl option

val lookup_ind_decl :
  global_env_ext -> ident -> nat -> one_inductive_body option

val name_from_term : global_env_ext -> term -> char list

val fresh_id_from : context -> nat -> char list -> char list

val fresh_name : global_env_ext -> context -> name -> term -> name

val print_term : global_env_ext -> context -> bool -> term -> char list
