open Bool
open CRelationClasses
open Compare_dec
open Datatypes
open Equality0
open List0
open Nat0
open OrderedType0
open PeanoNat
open Specif

type __ = Obj.t

val transport : 'a1 -> 'a1 -> 'a2 -> 'a2

type 'a pred = 'a -> bool

type ('a, 'b) isEquiv = { equiv : ('a -> 'b); equiv_inv : ('b -> 'a) }

val equiv : ('a1, 'a2) isEquiv -> 'a1 -> 'a2

val equiv_inv : ('a1, 'a2) isEquiv -> 'a2 -> 'a1

val on_snd : ('a2 -> 'a3) -> ('a1 * 'a2) -> 'a1 * 'a3

val test_snd : ('a2 -> bool) -> ('a1 * 'a2) -> bool

val option_get : 'a1 -> 'a1 option -> 'a1

type ('a, 'p) on_some = __

val option_default : ('a1 -> 'a2) -> 'a1 option -> 'a2 -> 'a2

type ('a, 'b, 'r) on_Trel = 'r

type coq_Fuel = nat

val fuel : coq_Fuel -> nat

val string_of_nat : nat -> char list

val fold_left_i_aux :
  ('a1 -> nat -> 'a2 -> 'a1) -> nat -> 'a2 list -> 'a1 -> 'a1

val fold_left_i : ('a1 -> nat -> 'a2 -> 'a1) -> 'a2 list -> 'a1 -> 'a1

val forallb2 : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list -> bool

val safe_nth : 'a1 list -> nat -> 'a1

val rev : 'a1 list -> 'a1 list

val rev_map : ('a1 -> 'a2) -> 'a1 list -> 'a2 list

val bool_compare : bool -> bool -> comparison

val bool_Compare : bool -> bool -> bool coq_Compare

val ascii_compare : char -> char -> comparison

val ascii_Compare : char -> char -> char coq_Compare

val string_compare : char list -> char list -> comparison

val string_Compare : char list -> char list -> char list coq_Compare

type ('a, 'p) coq_All =
| All_nil
| All_cons of 'a * 'a list * 'p * ('a, 'p) coq_All

val coq_All_rect :
  'a3 -> ('a1 -> 'a1 list -> 'a2 -> ('a1, 'a2) coq_All -> 'a3 -> 'a3) -> 'a1
  list -> ('a1, 'a2) coq_All -> 'a3

val coq_All_rec :
  'a3 -> ('a1 -> 'a1 list -> 'a2 -> ('a1, 'a2) coq_All -> 'a3 -> 'a3) -> 'a1
  list -> ('a1, 'a2) coq_All -> 'a3

type ('a, 'p) coq_Alli =
| Alli_nil
| Alli_cons of 'a * 'a list * 'p * ('a, 'p) coq_Alli

val coq_Alli_rect :
  (nat -> 'a3) -> (nat -> 'a1 -> 'a1 list -> 'a2 -> ('a1, 'a2) coq_Alli ->
  'a3 -> 'a3) -> nat -> 'a1 list -> ('a1, 'a2) coq_Alli -> 'a3

val coq_Alli_rec :
  (nat -> 'a3) -> (nat -> 'a1 -> 'a1 list -> 'a2 -> ('a1, 'a2) coq_Alli ->
  'a3 -> 'a3) -> nat -> 'a1 list -> ('a1, 'a2) coq_Alli -> 'a3

type ('a, 'b, 'r) coq_All2 =
| All2_nil
| All2_cons of 'a * 'b * 'a list * 'b list * 'r * ('a, 'b, 'r) coq_All2

val coq_All2_rect :
  'a4 -> ('a1 -> 'a2 -> 'a1 list -> 'a2 list -> 'a3 -> ('a1, 'a2, 'a3)
  coq_All2 -> 'a4 -> 'a4) -> 'a1 list -> 'a2 list -> ('a1, 'a2, 'a3) coq_All2
  -> 'a4

val coq_All2_rec :
  'a4 -> ('a1 -> 'a2 -> 'a1 list -> 'a2 list -> 'a3 -> ('a1, 'a2, 'a3)
  coq_All2 -> 'a4 -> 'a4) -> 'a1 list -> 'a2 list -> ('a1, 'a2, 'a3) coq_All2
  -> 'a4

type ('a, 'p) coq_OnOne2 =
| OnOne2_hd of 'a * 'a * 'a list * 'p
| OnOne2_tl of 'a * 'a list * 'a list * ('a, 'p) coq_OnOne2

val coq_OnOne2_rect :
  ('a1 -> 'a1 -> 'a1 list -> 'a2 -> 'a3) -> ('a1 -> 'a1 list -> 'a1 list ->
  ('a1, 'a2) coq_OnOne2 -> 'a3 -> 'a3) -> 'a1 list -> 'a1 list -> ('a1, 'a2)
  coq_OnOne2 -> 'a3

val coq_OnOne2_rec :
  ('a1 -> 'a1 -> 'a1 list -> 'a2 -> 'a3) -> ('a1 -> 'a1 list -> 'a1 list ->
  ('a1, 'a2) coq_OnOne2 -> 'a3 -> 'a3) -> 'a1 list -> 'a1 list -> ('a1, 'a2)
  coq_OnOne2 -> 'a3

val mapi_rec : (nat -> 'a1 -> 'a2) -> 'a1 list -> nat -> 'a2 list

val mapi : (nat -> 'a1 -> 'a2) -> 'a1 list -> 'a2 list

val rev_list_ind : 'a2 -> ('a1 -> 'a1 list -> 'a2 -> 'a2) -> 'a1 list -> 'a2

val rev_ind : 'a2 -> ('a1 -> 'a1 list -> 'a2 -> 'a2) -> 'a1 list -> 'a2

val forallb2_All2 :
  ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list -> ('a1, 'a1, __) coq_All2

val coq_All2_map :
  ('a1 -> 'a3) -> ('a2 -> 'a4) -> 'a1 list -> 'a2 list -> ('a1, 'a2, 'a5)
  coq_All2 -> ('a3, 'a4, 'a5) coq_All2

val coq_All2_map_inv :
  ('a1 -> 'a3) -> ('a2 -> 'a4) -> 'a1 list -> 'a2 list -> ('a3, 'a4, 'a5)
  coq_All2 -> ('a1, 'a2, 'a5) coq_All2

val coq_All2_All_mix_left :
  'a1 list -> 'a2 list -> ('a1, 'a3) coq_All -> ('a1, 'a2, 'a4) coq_All2 ->
  ('a1, 'a2, 'a3 * 'a4) coq_All2

val coq_All2_All_mix_right :
  'a1 list -> 'a2 list -> ('a2, 'a3) coq_All -> ('a1, 'a2, 'a4) coq_All2 ->
  ('a1, 'a2, 'a4 * 'a3) coq_All2

val coq_Forall_All : 'a1 list -> ('a1, __) coq_All

val forallb_All : 'a1 pred -> 'a1 list -> ('a1, __) coq_All

val coq_OnOne2_All_mix_left :
  'a1 list -> 'a1 list -> ('a1, 'a3) coq_All -> ('a1, 'a2) coq_OnOne2 ->
  ('a1, 'a2 * 'a3) coq_OnOne2

val coq_OnOne2_app :
  'a1 list -> 'a1 list -> 'a1 list -> ('a1, 'a2) coq_OnOne2 -> ('a1, 'a2)
  coq_OnOne2

val coq_OnOne2_mapP :
  'a1 list -> 'a1 list -> ('a1 -> 'a2) -> ('a1, __) coq_OnOne2 -> ('a2, __)
  coq_OnOne2

val coq_OnOne2_map :
  'a1 list -> 'a1 list -> ('a1 -> 'a2) -> ('a1, ('a2, 'a1, 'a3) on_Trel)
  coq_OnOne2 -> ('a2, 'a3) coq_OnOne2

val coq_OnOne2_sym :
  'a1 list -> 'a1 list -> ('a1, 'a2) coq_OnOne2 -> ('a1, 'a2) coq_OnOne2

val coq_OnOne2_exist :
  'a1 list -> 'a1 list -> ('a1, 'a2) coq_OnOne2 -> ('a1 -> 'a1 -> 'a2 ->
  ('a1, 'a3 * 'a3) sigT) -> ('a1 list, ('a1, 'a3) coq_OnOne2 * ('a1, 'a3)
  coq_OnOne2) sigT

val coq_All_firstn :
  'a1 list -> nat -> ('a1, 'a2) coq_All -> ('a1, 'a2) coq_All

val coq_All_skipn :
  'a1 list -> nat -> ('a1, 'a2) coq_All -> ('a1, 'a2) coq_All

val coq_All_app :
  'a1 list -> 'a1 list -> ('a1, 'a2) coq_All -> ('a1, 'a2) coq_All * ('a1,
  'a2) coq_All

val coq_All_app_inv :
  'a1 list -> 'a1 list -> ('a1, 'a2) coq_All -> ('a1, 'a2) coq_All -> ('a1,
  'a2) coq_All

val coq_All_mix :
  'a1 list -> ('a1, 'a2) coq_All -> ('a1, 'a3) coq_All -> ('a1, 'a2 * 'a3)
  coq_All

val coq_All2_All_left :
  'a1 list -> 'a2 list -> ('a1, 'a2, 'a3) coq_All2 -> ('a1 -> 'a2 -> 'a3 ->
  'a4) -> ('a1, 'a4) coq_All

val coq_All2_All_right :
  'a1 list -> 'a2 list -> ('a1, 'a2, 'a3) coq_All2 -> ('a1 -> 'a2 -> 'a3 ->
  'a4) -> ('a2, 'a4) coq_All

val coq_All2_right :
  'a1 list -> 'a2 list -> ('a1, 'a2, 'a3) coq_All2 -> ('a2, 'a3) coq_All

val coq_All_rev_map :
  ('a2 -> 'a1) -> 'a2 list -> ('a2, 'a3) coq_All -> ('a1, 'a3) coq_All

val coq_All_rev : 'a1 list -> ('a1, 'a2) coq_All -> ('a1, 'a2) coq_All

val coq_All_rev_inv : 'a1 list -> ('a1, 'a2) coq_All -> ('a1, 'a2) coq_All

val coq_All_impl :
  'a1 list -> ('a1, 'a2) coq_All -> ('a1 -> 'a2 -> 'a3) -> ('a1, 'a3) coq_All

val coq_Alli_impl :
  'a1 list -> nat -> ('a1, 'a2) coq_Alli -> (nat -> 'a1 -> 'a2 -> 'a3) ->
  ('a1, 'a3) coq_Alli

val coq_All_map :
  ('a1 -> 'a2) -> 'a1 list -> ('a1, 'a3) coq_All -> ('a2, 'a3) coq_All

val coq_All_map_inv :
  ('a1 -> 'a2) -> 'a1 list -> ('a2, __) coq_All -> ('a1, __) coq_All

val coq_All_nth_error : 'a1 list -> nat -> 'a1 -> ('a1, 'a2) coq_All -> 'a2

val coq_Alli_mix :
  nat -> 'a1 list -> ('a1, 'a2) coq_Alli -> ('a1, 'a3) coq_Alli -> ('a1,
  'a2 * 'a3) coq_Alli

val coq_Alli_All :
  'a1 list -> nat -> ('a1, 'a2) coq_Alli -> (nat -> 'a1 -> 'a2 -> 'a3) ->
  ('a1, 'a3) coq_All

val coq_Alli_app :
  nat -> 'a1 list -> 'a1 list -> ('a1, 'a2) coq_Alli -> ('a1, 'a2)
  coq_Alli * ('a1, 'a2) coq_Alli

val coq_Alli_nth_error :
  nat -> 'a1 list -> nat -> 'a1 -> ('a1, 'a2) coq_Alli -> 'a2

val map_eq_inj : ('a1 -> 'a2) -> ('a1 -> 'a2) -> 'a1 list -> ('a1, __) coq_All

val forall_nth_error_All :
  'a1 list -> (nat -> 'a1 -> __ -> 'a2) -> ('a1, 'a2) coq_All

val forall_nth_error_Alli :
  nat -> 'a1 list -> (nat -> 'a1 -> __ -> 'a2) -> ('a1, 'a2) coq_Alli

val coq_Alli_mapi :
  (nat -> 'a1 -> 'a2) -> nat -> 'a1 list -> (('a1, 'a3) coq_Alli, ('a2, 'a3)
  coq_Alli) isEquiv

val coq_Alli_shift :
  nat -> 'a1 list -> ('a1, 'a2) coq_Alli -> ('a1, 'a2) coq_Alli

val coq_Alli_rev :
  nat -> 'a1 list -> ('a1, 'a2) coq_Alli -> ('a1, 'a2) coq_Alli

val coq_Alli_All_mix :
  nat -> 'a1 list -> ('a1, 'a2) coq_Alli -> ('a1, 'a3) coq_All -> ('a1,
  'a2 * 'a3) coq_Alli

val coq_OnOne2_impl :
  'a1 list -> 'a1 list -> ('a1, 'a2) coq_OnOne2 -> ('a1 -> 'a1 -> 'a2 -> 'a3)
  -> ('a1, 'a3) coq_OnOne2

val coq_All2_impl :
  'a1 list -> 'a2 list -> ('a1, 'a2, 'a3) coq_All2 -> ('a1 -> 'a2 -> 'a3 ->
  'a4) -> ('a1, 'a2, 'a4) coq_All2

val coq_All_safe_nth : 'a1 list -> nat -> ('a1, 'a2) coq_All -> 'a2

type size = nat

val all_size : ('a1 -> 'a2 -> size) -> 'a1 list -> ('a1, 'a2) coq_All -> size

val alli_size :
  (nat -> 'a1 -> 'a2 -> size) -> 'a1 list -> nat -> ('a1, 'a2) coq_Alli ->
  size

val all2_size :
  ('a1 -> 'a1 -> 'a2 -> size) -> 'a1 list -> 'a1 list -> ('a1, 'a1, 'a2)
  coq_All2 -> size

type coq_BoolSpecSet =
| BoolSpecT
| BoolSpecF

val coq_BoolSpecSet_rect :
  (__ -> 'a1) -> (__ -> 'a1) -> bool -> coq_BoolSpecSet -> 'a1

val coq_BoolSpecSet_rec :
  (__ -> 'a1) -> (__ -> 'a1) -> bool -> coq_BoolSpecSet -> 'a1

val leb_spec_Set : nat -> nat -> coq_BoolSpecSet

type 'a nth_error_Spec =
| Coq_nth_error_Spec_Some of 'a
| Coq_nth_error_Spec_None

val nth_error_Spec_rect :
  'a1 list -> nat -> ('a1 -> __ -> __ -> 'a2) -> (__ -> 'a2) -> 'a1 option ->
  'a1 nth_error_Spec -> 'a2

val nth_error_Spec_rec :
  'a1 list -> nat -> ('a1 -> __ -> __ -> 'a2) -> (__ -> 'a2) -> 'a1 option ->
  'a1 nth_error_Spec -> 'a2

val nth_error_spec : 'a1 list -> nat -> 'a1 nth_error_Spec

val nth_error_all : 'a1 list -> nat -> 'a1 -> ('a1, 'a2) coq_All -> 'a2

val nth_error_alli :
  'a1 list -> nat -> 'a1 -> nat -> ('a1, 'a2) coq_Alli -> 'a2

val chop : nat -> 'a1 list -> 'a1 list * 'a1 list

val on_pi2 : ('a2 -> 'a2) -> (('a1 * 'a2) * 'a3) -> ('a1 * 'a2) * 'a3

val map_option_out : 'a1 option list -> 'a1 list option

val coq_All2_app_inv :
  'a2 list -> 'a1 list -> 'a1 list -> ('a1, 'a2, 'a3) coq_All2 -> ('a2
  list * 'a2 list, __) sigT

val coq_All2_app :
  'a1 list -> 'a1 list -> 'a2 list -> 'a2 list -> ('a1, 'a2, 'a3) coq_All2 ->
  ('a1, 'a2, 'a3) coq_All2 -> ('a1, 'a2, 'a3) coq_All2

val coq_All2_impl_In :
  'a1 list -> 'a2 list -> ('a1, 'a2, 'a3) coq_All2 -> ('a1 -> 'a2 -> __ -> __
  -> 'a3 -> 'a4) -> ('a1, 'a2, 'a4) coq_All2

val coq_All2_All : 'a1 list -> ('a1, 'a1, 'a2) coq_All2 -> ('a1, 'a2) coq_All

type 'a coq_ComparableType =
  'a -> 'a -> comparison
  (* singleton inductive, whose constructor was Build_ComparableType *)

val compare : 'a1 coq_ComparableType -> 'a1 -> 'a1 -> comparison

val insert : 'a1 coq_ComparableType -> 'a1 -> 'a1 list -> 'a1 list

val list_union : 'a1 coq_ComparableType -> 'a1 list -> 'a1 list -> 'a1 list

val compare_bool : bool -> bool -> comparison

val bool_lt' : bool -> bool -> bool

val coq_All2_nth :
  'a1 list -> 'a2 list -> nat -> 'a1 -> 'a2 -> ('a1, 'a2, 'a3) coq_All2 ->
  'a3 -> 'a3

val coq_OnOne2_ind_l :
  ('a1 list -> 'a1 -> 'a1 -> 'a1 list -> 'a2 -> 'a3) -> ('a1 list -> 'a1 ->
  'a1 list -> 'a1 list -> ('a1, 'a2) coq_OnOne2 -> 'a3 -> 'a3) -> 'a1 list ->
  'a1 list -> ('a1, 'a2) coq_OnOne2 -> 'a3

val coq_All2_mapi :
  (nat -> 'a1 -> 'a3) -> (nat -> 'a2 -> 'a4) -> 'a1 list -> 'a2 list -> ('a1,
  'a2, nat -> 'a5) coq_All2 -> ('a3, 'a4, 'a5) coq_All2

val coq_OnOne2_impl_exist_and_All :
  'a1 list -> 'a1 list -> 'a1 list -> ('a1, 'a2) coq_OnOne2 -> ('a1, 'a1,
  'a3) coq_All2 -> ('a1 -> 'a1 -> 'a1 -> 'a2 -> 'a3 -> ('a1, 'a4 * 'a3) sigT)
  -> ('a1 list, ('a1, 'a4) coq_OnOne2 * ('a1, 'a1, 'a3) coq_All2) sigT

val coq_OnOne2_impl_exist_and_All_r :
  'a1 list -> 'a1 list -> 'a1 list -> ('a1, 'a2) coq_OnOne2 -> ('a1, 'a1,
  'a3) coq_All2 -> ('a1 -> 'a1 -> 'a1 -> 'a2 -> 'a3 -> ('a1, 'a4 * 'a3) sigT)
  -> ('a1 list, ('a1, 'a4) coq_OnOne2 * ('a1, 'a1, 'a3) coq_All2) sigT

val coq_All2_skipn :
  'a1 list -> 'a2 list -> nat -> ('a1, 'a2, 'a3) coq_All2 -> ('a1, 'a2, 'a3)
  coq_All2

val coq_All2_rev :
  'a1 list -> 'a1 list -> ('a1, 'a1, 'a2) coq_All2 -> ('a1, 'a1, 'a2) coq_All2

module NEL :
 sig
  type 'a t =
  | Coq_sing of 'a
  | Coq_cons of 'a * 'a t

  val t_rect : ('a1 -> 'a2) -> ('a1 -> 'a1 t -> 'a2 -> 'a2) -> 'a1 t -> 'a2

  val t_rec : ('a1 -> 'a2) -> ('a1 -> 'a1 t -> 'a2 -> 'a2) -> 'a1 t -> 'a2

  val length : 'a1 t -> nat

  val to_list : 'a1 t -> 'a1 list

  val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t

  val app : 'a1 t -> 'a1 t -> 'a1 t

  val app_r : 'a1 list -> 'a1 t -> 'a1 t

  val cons' : 'a1 -> 'a1 list -> 'a1 t

  val fold_left : ('a1 -> 'a2 -> 'a1) -> 'a2 t -> 'a1 -> 'a1

  val forallb : ('a1 -> bool) -> 'a1 t -> bool

  val forallb2 : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool
 end

type 'a non_empty_list = 'a NEL.t

val coq_All2_right_triv :
  'a1 list -> 'a2 list -> ('a2, 'a3) coq_All -> ('a1, 'a2, 'a3) coq_All2

val coq_All_repeat : nat -> 'a1 -> 'a2 -> ('a1, 'a2) coq_All

val coq_All2_map_left :
  'a2 list -> 'a3 list -> ('a2 -> 'a1) -> ('a2, 'a3, 'a4) coq_All2 -> ('a1,
  'a3, 'a4) coq_All2

val coq_All2_map_right :
  'a1 list -> 'a2 list -> ('a2 -> 'a3) -> ('a1, 'a2, 'a4) coq_All2 -> ('a1,
  'a3, 'a4) coq_All2

val coq_All2_from_nth_error :
  'a1 list -> 'a2 list -> (nat -> 'a1 -> 'a2 -> __ -> __ -> __ -> 'a3) ->
  ('a1, 'a2, 'a3) coq_All2

val coq_All2_nth_error :
  'a1 list -> 'a2 list -> nat -> 'a1 -> 'a2 -> ('a1, 'a2, 'a3) coq_All2 -> 'a3

val coq_All2_swap :
  'a1 list -> 'a2 list -> ('a1, 'a2, 'a3) coq_All2 -> ('a2, 'a1, 'a3) coq_All2

val coq_All2_firstn :
  'a1 list -> 'a2 list -> nat -> ('a1, 'a2, 'a3) coq_All2 -> ('a1, 'a2, 'a3)
  coq_All2

val coq_All2_app_inv_r :
  'a1 list -> 'a2 list -> 'a2 list -> ('a1, 'a2, 'a3) coq_All2 -> ('a1 list,
  ('a1 list, __ * (('a1, 'a2, 'a3) coq_All2 * ('a1, 'a2, 'a3) coq_All2))
  sigT) sigT

val list_rect_rev : 'a2 -> ('a1 -> 'a1 list -> 'a2 -> 'a2) -> 'a1 list -> 'a2

val todo : char list -> 'a1

val coq_All2_trans :
  ('a1, 'a2) coq_Transitive -> ('a1 list, ('a1, 'a1, 'a2) coq_All2)
  coq_Transitive

val coq_All2_impl' :
  'a1 list -> 'a2 list -> ('a1, 'a2, 'a3) coq_All2 -> ('a1, 'a2 -> 'a3 ->
  'a4) coq_All -> ('a1, 'a2, 'a4) coq_All2

val coq_All_All2 :
  'a1 list -> ('a1, 'a3) coq_All -> ('a1 -> 'a3 -> 'a2) -> ('a1, 'a1, 'a2)
  coq_All2

val coq_All2_nth_error_Some :
  'a1 list -> 'a2 list -> nat -> 'a1 -> ('a1, 'a2, 'a3) coq_All2 -> ('a2,
  __ * 'a3) sigT

val coq_All2_nth_error_Some_r :
  'a1 list -> 'a2 list -> nat -> 'a2 -> ('a1, 'a2, 'a3) coq_All2 -> ('a1,
  __ * 'a3) sigT

val coq_All2_same : 'a1 list -> ('a1 -> 'a2) -> ('a1, 'a1, 'a2) coq_All2

val coq_All2_prod :
  'a1 list -> 'a1 list -> ('a1, 'a1, 'a2) coq_All2 -> ('a1, 'a1, 'a3)
  coq_All2 -> ('a1, 'a1, 'a2 * 'a3) coq_All2

val coq_All2_prod_inv :
  'a1 list -> 'a1 list -> ('a1, 'a1, 'a2 * 'a3) coq_All2 -> ('a1, 'a1, 'a2)
  coq_All2 * ('a1, 'a1, 'a3) coq_All2

val coq_All2_sym :
  'a1 list -> 'a1 list -> ('a1, 'a1, 'a2) coq_All2 -> ('a1, 'a1, 'a2) coq_All2

val coq_All2_symP :
  ('a1, 'a2) coq_Symmetric -> ('a1 list, ('a1, 'a1, 'a2) coq_All2)
  coq_Symmetric

val coq_All_All2_All2_mix :
  'a1 list -> 'a2 list -> 'a2 list -> ('a1, 'a2 -> 'a2 -> 'a4 -> 'a5 -> ('a2,
  'a3 * 'a3) sigT) coq_All -> ('a1, 'a2, 'a4) coq_All2 -> ('a1, 'a2, 'a5)
  coq_All2 -> ('a2 list, ('a2, 'a2, 'a3) coq_All2 * ('a2, 'a2, 'a3) coq_All2)
  sigT

val forallb_nth' : 'a1 list -> ('a1 -> bool) -> nat -> 'a1 -> bool

val coq_All_prod_inv :
  'a1 list -> ('a1, 'a2 * 'a3) coq_All -> ('a1, 'a2) coq_All * ('a1, 'a3)
  coq_All

val coq_All_prod :
  'a1 list -> ('a1, 'a2) coq_All -> ('a1, 'a3) coq_All -> ('a1, 'a2 * 'a3)
  coq_All
